﻿Option Strict On
Option Explicit On

Imports WMPLib
Imports System.Runtime.InteropServices

Public Class Form1

    Private m_WMPCdrom As IWMPCdrom = Nothing
    Private m_WMPCdromBurn As IWMPCdromBurn = Nothing
    Private m_WMPCdromCollection As IWMPCdromCollection = Nothing
    Private m_WMPPlaylistArray As IWMPPlaylistArray = Nothing
    Private m_WMPPlaylist As IWMPPlaylist = Nothing
    Private m_WMPMedia As IWMPMedia = Nothing

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        m_WMPCdromCollection = AxWmp.cdromCollection
        If m_WMPCdromCollection IsNot Nothing Then
            Dim intWMPCdromCollectionCount As Integer = m_WMPCdromCollection.count
            If intWMPCdromCollectionCount > 0 Then
                For intWMPCdromCollectionItem = 0 To intWMPCdromCollectionCount - 1
                    m_WMPCdrom = m_WMPCdromCollection.Item(intWMPCdromCollectionItem)
                    If m_WMPCdrom IsNot Nothing Then
                        m_WMPCdromBurn = DirectCast(m_WMPCdrom, IWMPCdromBurn)
                        If m_WMPCdromBurn IsNot Nothing Then
                            If m_WMPCdromBurn.isAvailable("Burn") Then
                                CbxCDRomDrives.Items.Add(m_WMPCdrom.driveSpecifier)
                            End If
                        End If
                    End If
                Next
                CbxCDRomDrives.SelectedIndex = 0
            End If
        End If


        m_WMPPlaylistArray = DirectCast(AxWmp.playlistCollection.getAll(), IWMPPlaylistArray)
        If m_WMPPlaylistArray IsNot Nothing Then
            Dim intWMPPlaylistArrayCount As Integer = m_WMPPlaylistArray.count
            If intWMPPlaylistArrayCount > 0 Then
                For intWMPPlaylistArrayItem = 0 To intWMPPlaylistArrayCount - 1
                    m_WMPPlaylist = m_WMPPlaylistArray.Item(intWMPPlaylistArrayItem)
                    If m_WMPPlaylist IsNot Nothing Then
                        CbxPlaylists.Items.Add(m_WMPPlaylist.name)
                    End If
                Next
                CbxPlaylists.SelectedIndex = 0
            End If
        End If

    End Sub

    Private Sub CbxPlaylists_SelectedIndexChanged(sender As Object, e As EventArgs) Handles CbxPlaylists.SelectedIndexChanged
        LbxMedia.Items.Clear()

        m_WMPPlaylist = DirectCast(AxWmp.playlistCollection.getByName(CbxPlaylists.SelectedItem.ToString).Item(0), IWMPPlaylist)
        If m_WMPPlaylist IsNot Nothing Then
            Dim intWMPPlaylistCount As Integer = m_WMPPlaylist.count
            If intWMPPlaylistCount > 0 Then
                For intWMPPlaylistItem = 0 To intWMPPlaylistCount - 1
                    m_WMPMedia = m_WMPPlaylist.Item(intWMPPlaylistItem)
                    If m_WMPMedia IsNot Nothing Then
                        LbxMedia.Items.Add(m_WMPMedia.name)
                    End If
                Next
            End If
        End If
    End Sub

    Private Sub BtnBurn_Click(sender As Object, e As EventArgs) Handles BtnBurn.Click

        m_WMPCdromBurn = CType(AxWmp.cdromCollection.getByDriveSpecifier(CbxCDRomDrives.SelectedItem.ToString), IWMPCdromBurn)
        If m_WMPCdromBurn IsNot Nothing Then
            If m_WMPCdromBurn.isAvailable("Burn") Then
                If m_WMPCdromBurn.isAvailable("Disc") Then
                    m_WMPPlaylist = CType(AxWmp.playlistCollection.getByName(CbxPlaylists.SelectedItem.ToString).Item(0), IWMPPlaylist)
                    If m_WMPPlaylist IsNot Nothing Then
                        m_WMPCdromBurn.burnPlaylist = m_WMPPlaylist
                        m_WMPCdromBurn.burnFormat = WMPBurnFormat.wmpbfAudioCD
                        m_WMPCdromBurn.refreshStatus()
                        m_WMPCdromBurn.startBurn()
                    End If
                Else
                    MessageBox.Show("Please insert a CD.")
                End If
            End If
        End If
    End Sub

    Private Sub BtnPreview_Click(sender As Object, e As EventArgs) Handles BtnPreview.Click
        m_WMPPlaylist = CType(AxWmp.playlistCollection.getByName(CbxPlaylists.SelectedItem.ToString).Item(0), IWMPPlaylist)
        If m_WMPPlaylist IsNot Nothing Then
            AxWmp.settings.autoStart = True
            AxWmp.currentPlaylist = m_WMPPlaylist
        End If
    End Sub
End Class
